
const fs = require('fs');
const path = require('path');
const parseArgs = require('subarg');

// get arguments
const args = process.argv.slice(2);

const parsedArgs = parseArgs(args, {
	alias: {
		sourceMap: 'source-map',
		version: 'v',
		port: 'p',
		build: 'b',
		install: 'I',
		template: 't',
		open: 'o',
		new: 'n',
		dimension: 'd',
		'help': 'h'
	},
	'--': true}
);

console.log(parsedArgs);
const [command, fileName] = parsedArgs._;

console.log('command: ' + command);
console.log('fileName: ' + fileName);

if(command === 'create' && fileName !== undefined)
{
	if(!fs.existsSync(papersFile)){
		console.error('File not found: ' + papersFile + ' in ' + papersDir);
		console.log(papersFile + ' file will be created in ' + papersDir);

		//read the file content in template directory
		const templateDir = path.join(__dirname, 'templates');
		const templateFile = path.join(templateDir, 'hitTest.js');
		const templateContent = fs.readFileSync(templateFile, 'utf8');

		// crete the file in papers directory
		fs.writeFileSync(papersFile, templateContent, 'utf8');
	}
}
else if(command === 'open' && fileName !== undefined)
{
	// copy the file from papers directory to the tmp directory
	const papersDir = path.join(__dirname, 'papers');
	const papersFile = path.join(papersDir, fileName);

	// open the file in tmp directory
	const tmpDir = path.join(__dirname, 'tmp');
	const tmpFile = path.join(tmpDir, fileName);
	fs.mkdirSync(tmpDir, {recursive: true});
	fs.copyFileSync(papersFile, tmpFile);	

	// rename the file in tmp directory
	const newFileName = fileName.replace('.js', '.ts');
	const newTmpFile = path.join(tmpDir, newFileName);
	fs.renameSync(tmpFile, path.join(tmpDir, 'tmp.js'));
}
else
	console.error('No file name specified');