import { Group, paper, Path, Point, PointText } from "paper";
import {} from '../utils/arrayOperations'
import chars from './char2pixels.json'

const canvas = document.getElementById("paperCanvas");
paper.install(window);
paper.setup(canvas);

var vanishPoint = new Point(1800, 680)
var startX = 466;
var width = 42;
var height = 40;

var diff0 = vanishPoint.x - startX;
var offset = startX, compress;

var blocks = []
var columnSize = 40;

new Path({fillColor: '#bbb', segments: [[startX, 200], vanishPoint, [startX, 12 * columnSize + 200]]}) 


for(var k=0; k < columnSize; k++){
    compress = (vanishPoint.x - offset) / diff0;
    offset += 8 * compress;
        
    var vertical1 = new Path.Line({
        from: [offset, 0], to:   [offset, 1000],
        strokeWidth:0, strokeColor: 'black'});
        
    offset += width * compress;
        
    var vertical2 = new Path.Line({
        from: [offset, 0], to:   [offset, 1000], 
        strokeWidth:0, strokeColor: 'black'});
        
    var column = []    
    for(var i=0; i<12; i++){
        var l1 = new Path.Line({
            from: new Point(startX, 200 + height * i),
            to: vanishPoint,
            strokeColor: 'black',
            strokeWidth: 6
        })
        
        var l2 = new Path.Line({
            from: new Point(startX, 200 + height * (i+1)),
            to: vanishPoint,
            strokeColor: 'black',
            strokeWidth: 0
        })
        
        var topLeft = l1.getIntersections(vertical1)[0].point
        var topRight = l1.getIntersections(vertical2)[0].point
        
        var bottomLeft = l2.getIntersections(vertical1)[0].point
        var bottomRight = l2.getIntersections(vertical2)[0].point
        
        var block = new Path([topLeft, topRight, bottomRight, bottomLeft]);
        block.closed = true;
        block.fillColor = 'black';
        block.strokeWidth = 0;

        // block.strokeColor = 'black'
        
        column.push(block);
    }
    blocks.push(column)
}



concatBlocks = (matrix1, matrix2) => {
  const matrix = new Array(matrix1.length).fill(0).map(() => new Array(matrix1[0].length + matrix2[0].length).fill(0));

  for(let i=0; i<matrix1.length; i++){
    for(let j=0; j<matrix1[0].length; j++){
      matrix[i][j] = matrix1[i][j]
    }
  }

  for(let i=0; i<matrix2.length; i++){
    for(let j=0; j<matrix2[0].length; j++){
      matrix[i][j+matrix1[0].length] = matrix2[i][j]
    }
  }
  return matrix;
}

charToBlock = (char) => {
  const charPixels = chars[char];
  const matrix = new Array(12).fill(0).map(() => new Array(8).fill(0)); // 12 rows, 8 columns

  for(let i=0; i<charPixels.length; i++){
    const pixel = charPixels[i];

    for(let j=0; j<pixel.length; j++){
      if(pixel[j] === '1'){
        matrix[i+2][j] = 1
      }
      else
        matrix[i+2][j] = 0
    }
  }
  return matrix;
}

drawBlocks = (matrix, step) => {
  for(let i=0; i<matrix.length; i++){
    for(let j=step; j<step + columnSize; j++){
      if(matrix[i][j] === 1){
        blocks[j-step][i].fillColor = 'yellow'
      }
      else
        blocks[j-step][i].fillColor = 'black'
    }
  }
}

textToBlocks = (text) => {
  let char = text[0];
  let temp = charToBlock(char);

  for(let i=1; i<text.length; i++){
    char = text[i];
    temp = concatBlocks(temp, charToBlock(char))
  }
  return temp;
}

const charBlocks = textToBlocks('NEVER GONNA GIVE YOU UP!');
drawBlocks(charBlocks, 0);

paper.project.view.onFrame = (event) => {
  if(event.count % 10 === 0){
    const step = (event.count/10) % (charBlocks[0].length + 40) - 40
    drawBlocks(charBlocks, step)

    for(let i=0; i<charBlocks.length; i++){
      blocks[9][i].fillColor = 'rgba(0, 0, 0, 0.2)'
      blocks[10][i].fillColor = 'rgba(0, 0, 0, 0.2)'
      blocks[9][i].strokeColor = 'rgba(0, 0, 0, 0.2)'
      blocks[10][i].strokeColor = 'rgba(0, 0, 0, 0.2)'

      blocks[22][i].fillColor = 'rgba(0, 0, 0, 0.2)'
      blocks[23][i].fillColor = 'rgba(0, 0, 0, 0.2)'
      blocks[22][i].strokeColor = 'rgba(0, 0, 0, 0.2)'
      blocks[23][i].strokeColor = 'rgba(0, 0, 0, 0.2)'

      blocks[34][i].fillColor = 'rgba(0, 0, 0, 0.2)'
      blocks[35][i].fillColor = 'rgba(0, 0, 0, 0.2)'
      blocks[34][i].strokeColor = 'rgba(0, 0, 0, 0.2)'
      blocks[35][i].strokeColor = 'rgba(0, 0, 0, 0.2)'
    }
  }
}

var vanishPoint = new Point(-1000, 500)

const p = new Path({strokeColor: 'black', fillColor: 'black', strokeWidth: 1});
p.segments = [vanishPoint, blocks[0][0].bounds.topLeft, blocks[0][11].bounds.bottomLeft, vanishPoint]


new Path({fillColor: 'black', segments: [blocks[11][0].bounds.topLeft, vanishPoint, blocks[11][11].bounds.bottomLeft,]}).sendToBack()

new Path.Rectangle({
  from: blocks[24][0].bounds.topLeft.subtract([68, 0]),
  to: blocks[24][11].bounds.bottomLeft,
  fillColor: 'black',
})

new Path.Rectangle({
  from: blocks[36][0].bounds.topLeft.subtract([38, 0]),
  to: blocks[36][11].bounds.bottomLeft,
  fillColor: 'black',
})

blocks[9][i].bounds.topLeft
