import { Group, paper, Path, Point, PointText, Tool } from "paper";
import { Pane } from 'tweakpane';
import {} from '../utils/arrayOperations'
import { range } from '../utils/rand'
import random from 'canvas-sketch-util/random';


class Circle {
  constructor(x,y, radius){ 
    this.x = x;
    this.y = y;
    this.radius = radius;
  }
  draw(){
    this.drawing = new Path.Circle({
      center: [this.x, this.y],
      radius: this.radius,
      strokeColor: 'black',
      // strokeWidth: 3,
      fillColor: 'black'
    });
  }
  move(x,y){
    this.x = x;
    this.y = y;
    this.drawing.position = [this.x, this.y];
  }
}

const canvas = document.getElementById("paperCanvas");
paper.install(window);
paper.setup(canvas);

paper.project.view.onFrame = (event) => {
  // if(event.count % 2 !== 0) return;
  paper.project.activeLayer.removeChildren();

  for(var i=0; i < 2200; i++){
    const y = Math.floor(i/60);
    const x = i%60;
    // console.log(x,y)
    const rand = random.noise2D(x, y + event.count * 1, 0.06) * 20;
    // console.log(rand)
    // if(rand < 4) continue;
    new Circle(20 * x + 200, 20* y + 60, rand).draw()
  }
}